//
//  EMS.swift
//  Tremor GUI
//
//  Created by Tremors on 4/17/18.
//  Copyright © 2018 Tremors. All rights reserved.
//

import Foundation
import UIKit
import CoreBluetooth


let ems=EMS()


struct EMS {
    
    
    //  need function that checks wether or not bluetooth is connected  , is ems ready?
    // if it is not it will not allow you to press the button that will call a function to send ble data
    
        let c1up="K" // pin 1
        let c1down="J" // pin 0
        let left="L" //pin 9  aka down
        let right="M" // pin 2 aka up
        let set="N"  // pin 3 // will likely have to change to 5 or wtvr it is on the board later !!!!!!\
    //m is set
    // set takes tn second to finis
    //J is for led
    //0 1 9 2 3

    let junk="b"
    
    func send_asci(asciVal: String)  {
        sendValue(data: asciVal)
        sendjunk()
        
    }
    
    func press_C1up(){
        sendValue(data: c1up)
        sendjunk()
        
        
    }
    
    func press_C1down(){
        sendValue(data: c1down)
        sendjunk()
    }
    
    func press_left(){
        sendValue(data: left)
        sendjunk()
    }
    
    func press_right(){
        sendValue(data: right)
        sendjunk()
    }
    
    func press_set(){
        
        sendValue(data: set)
        sendjunk()
    }
    
    
    
    // junk function since currently to read two writes must be performed
    func  sendjunk() {
        sendValue(data: junk)
    }
    
}
func sendValue(data: String){
    let valueString = (data as NSString).data(using: String.Encoding.utf8.rawValue)
    //change the "data" to valueString
    if let blePeripheral = blePeripheral{
        if let txCharacteristic = txCharacteristic {
            blePeripheral.writeValue(valueString!, for: txCharacteristic, type: CBCharacteristicWriteType.withResponse)
        }
    }
}











